/*
 * @(#)CpeProcPropertyDialog.java	1.0 98/1/5
 * 
 */

// TODO: Fix the other and Issues list updates.

import java.awt.event.*;
import java.lang.reflect.*;
import java.util.*;
import CpeProcessPanel;
import Cpe;
import com.sun.java.swing.*;
import java.awt.*;

/**
 * CpeProcPropertyDialog is used to display/set properties of the
 * process network.
 *
 * @version 1.0 98/1/5
 * @author Steve Polyak 
 */
public class CpeProcPropertyDialog extends JDialog {
  protected Button btnOK;
  protected Button btnCancel;
  protected JTextField txtName = null;
  protected JTextField expands = null;
  protected CpeProcessPanel m_panel = null;
  protected String m_oldText = "";
  protected String m_oldKey = "";
  protected ButtonGroup group;
  protected JTabbedPane tab;

  protected JTextField reqInput;
  protected DefaultListModel reqList;
  protected JTextField prefInput;
  protected DefaultListModel prefList;
  protected JTextField varInput;
  protected DefaultListModel varList;
  protected JTextField condInput;
  protected DefaultListModel condList;
  protected JTextField effInput;
  protected DefaultListModel effList;
  protected JTextField resInput;
  protected DefaultListModel resList;
  protected JTextField objInput;
  protected DefaultListModel objList;
  protected JTextField issInput;
  protected DefaultListModel issList;
  protected JTextField otherInput;
  protected DefaultListModel otherList;

  CpeProcPropertyDialog(CpeProcessPanel parent, String title) {
    // Create a dialog with the specified title
    super(Cpe.sharedInstance().getFrame(), title, false);
    m_panel = parent;

    tab = new JTabbedPane();
    
    //    this.setLayout(new BorderLayout(25,5));
    this.getContentPane().setLayout(new BorderLayout(25,5));
    JPanel fields = new JPanel();
    fields.setLayout(new GridLayout(3,2));
    fields.add (new Label("Process Name:"));
    m_oldText = m_panel.process.label;
    m_oldKey = m_panel.process.key;
    txtName = new JTextField(m_oldText);
    fields.add (txtName);

    fields.add (new Label("Expands:"));
    expands = new JTextField(m_panel.process.expands);
    fields.add (expands);

    //bounding nodes gui
    fields.add (new Label("Bounding Nodes:"));
    JPanel radioPanel = new JPanel();
    radioPanel.setLayout(new GridLayout(1,2));
    group = new ButtonGroup();
    JRadioButton button;
    button = new JRadioButton("Start-Finish", m_panel.process.startFinishFlag);
    button.setActionCommand("sf");
    group.add(button);
    radioPanel.add (button);
    button = new JRadioButton("Begin-End", 
			      (! m_panel.process.startFinishFlag));
    button.setActionCommand("be");
    group.add(button);
    radioPanel.add(button);
    fields.add (radioPanel);

    tab.addTab("General",null,fields);

    //objectives gui
    JPanel objPanel = new JPanel();
    objPanel.setLayout(new BorderLayout(25,5));
    JPanel objPanel1 = new JPanel();
    objPanel1.setLayout(new GridLayout(2,1));
    objInput = new JTextField();
    objPanel1.add(objInput);
    objList = new DefaultListModel();
    objPanel1.add(new JScrollPane
		  (new JList(objList), 
		   ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS, 
		   ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS));
    objPanel.add("Center",objPanel1);

    JPanel objPanel2 = new JPanel();
    JButton addObjBtn = new JButton("Add");
    addObjBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	objList.addElement(objInput.getText());
	objInput.setText("");
      }
    });
    objPanel2.add(addObjBtn);
    JButton delObjBtn = new JButton("Delete");
    delObjBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	objList.removeAllElements();
      }
    });
    objPanel2.add(delObjBtn);
    objPanel.add("South",objPanel2);
    tab.addTab("Objectives",null,objPanel);

    //issues gui
    JPanel issPanel = new JPanel();
    issPanel.setLayout(new BorderLayout(25,5));
    JPanel issPanel1 = new JPanel();
    issPanel1.setLayout(new GridLayout(2,1));
    issInput = new JTextField();
    issPanel1.add(issInput);
    issList = new DefaultListModel();
    issPanel1.add(new JScrollPane
		  (new JList(issList), 
		   ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS, 
		   ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS));
    issPanel.add("Center",issPanel1);

    JPanel issPanel2 = new JPanel();
    JButton addIssBtn = new JButton("Add");
    addIssBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	issList.addElement(issInput.getText());
	issInput.setText("");
      }
    });
    issPanel2.add(addIssBtn);
    JButton delIssBtn = new JButton("Delete");
    delIssBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	issList.removeAllElements();
      }
    });
    issPanel2.add(delIssBtn);
    JButton expIssBtn = new JButton("Build...");
    expIssBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	
	try {
	  //Lookup class
	  Class c = Class.forName(Cpe.sharedInstance().expClassName);

	  //Create new instance
	  Object expBuilder = null;
	  expBuilder = c.newInstance();

	  //Fetch method and invoke it
	  Class parameters[] = new Class[0];
	  Method m = c.getMethod("buildIssue",parameters);
	  Object[] args = new Object[0];
	  Object target = new Object();
	  String result = (String) m.invoke(expBuilder, args);

	  if (!(result.equals(""))){
	    issInput.setText(result);
	  }
	}
	catch (IllegalAccessException eill){}
	catch (InstantiationException inst){
	  JOptionPane.showMessageDialog
	    (Cpe.sharedInstance().getFrame(), 
	     "Selected component is illegal. Consult the Options menu.",
	     "CPE Message", 
	     JOptionPane.WARNING_MESSAGE);
	  return;	
	}
	catch (InvocationTargetException etarg){}
	catch (ClassNotFoundException enotf){
	  JOptionPane.showMessageDialog
	    (Cpe.sharedInstance().getFrame(), 
	     "Selected component is illegal. Consult the Options menu.",
	     "CPE Message", 
	     JOptionPane.WARNING_MESSAGE);
	  return;
	}
	catch (NoSuchMethodException enos){
	  JOptionPane.showMessageDialog
	    (Cpe.sharedInstance().getFrame(), 
	     "Selected component is illegal. Consult the Options menu.",
	     "CPE Message", 
	     JOptionPane.WARNING_MESSAGE);
	  return;
	}
      }
    });
    issPanel2.add(expIssBtn);
    issPanel.add("South",issPanel2);
    tab.addTab("Issues",null,issPanel);

    //requirements gui
    JPanel reqPanel = new JPanel();
    reqPanel.setLayout(new BorderLayout(25,5));
    JPanel reqPanel1 = new JPanel();
    reqPanel1.setLayout(new GridLayout(2,1));
    reqInput = new JTextField();
    reqPanel1.add(reqInput);
    reqList = new DefaultListModel();
    reqPanel1.add(new JScrollPane
		  (new JList(reqList), 
		   ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS, 
		   ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS));
    reqPanel.add("Center",reqPanel1);

    JPanel reqPanel2 = new JPanel();
    JButton addRBtn = new JButton("Add");
    addRBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	reqList.addElement(reqInput.getText());
	reqInput.setText("");
      }
    });
    reqPanel2.add(addRBtn);
    JButton delRBtn = new JButton("Delete");
    delRBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	reqList.removeAllElements();
      }
    });
    reqPanel2.add(delRBtn);
    reqPanel.add("South",reqPanel2);
    //tab.addTab("Requirements",null,reqPanel);

    //preferences gui
    JPanel prefPanel = new JPanel();
    prefPanel.setLayout(new BorderLayout(25,5));
    JPanel prefPanel1 = new JPanel();
    prefPanel1.setLayout(new GridLayout(2,1));
    prefInput = new JTextField();
    prefPanel1.add(prefInput);
    prefList = new DefaultListModel();
    prefPanel1.add(new JScrollPane
		   (new JList(prefList), 
		    ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS, 
		    ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS));
    prefPanel.add("Center",prefPanel1);

    JPanel prefPanel2 = new JPanel();
    JButton addPBtn = new JButton("Add");
    addPBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	prefList.addElement(prefInput.getText());
	prefInput.setText("");
      }
    });
    prefPanel2.add(addPBtn);
    JButton delPBtn = new JButton("Delete");
    delPBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	prefList.removeAllElements();
      }
    });
    prefPanel2.add(delPBtn);
    prefPanel.add("South",prefPanel2);
    //tab.addTab("Preferences",null,prefPanel);

    //variables gui
    JPanel varPanel = new JPanel();
    varPanel.setLayout(new BorderLayout(25,5));
    JPanel varPanel1 = new JPanel();
    varPanel1.setLayout(new GridLayout(2,1));
    varInput = new JTextField();
    varPanel1.add(varInput);
    varList = new DefaultListModel();
    varPanel1.add(new JScrollPane
		  (new JList(varList), 
		   ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS, 
		   ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS));
    varPanel.add("Center",varPanel1);

    JPanel varPanel2 = new JPanel();
    JButton addVBtn = new JButton("Add");
    addVBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	varList.addElement(varInput.getText());
	varInput.setText("");
      }
    });
    varPanel2.add(addVBtn);
    JButton delVBtn = new JButton("Delete");
    delVBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	varList.removeAllElements();
      }
    });
    varPanel2.add(delVBtn);
    varPanel.add("South",varPanel2);
    tab.addTab("Variables",null,varPanel);

    //resources gui
    JPanel resPanel = new JPanel();
    resPanel.setLayout(new BorderLayout(25,5));
    JPanel resPanel1 = new JPanel();
    resPanel1.setLayout(new GridLayout(2,1));
    resInput = new JTextField();
    resPanel1.add(resInput);
    resList = new DefaultListModel();
    resPanel1.add(new JScrollPane
		  (new JList(resList), 
		   ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS, 
		   ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS));
    resPanel.add("Center",resPanel1);

    JPanel resPanel2 = new JPanel();
    JButton addRsBtn = new JButton("Add");
    addRsBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	resList.addElement(resInput.getText());
	resInput.setText("");
      }
    });
    resPanel2.add(addRsBtn);
    JButton delRsBtn = new JButton("Delete");
    delRsBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	resList.removeAllElements();
      }
    });
    resPanel2.add(delRsBtn);
    resPanel.add("South",resPanel2);
    tab.addTab("Resources",null,resPanel);

    //conditions gui
    JPanel condPanel = new JPanel();
    condPanel.setLayout(new BorderLayout(25,5));
    JPanel condPanel1 = new JPanel();
    condPanel1.setLayout(new GridLayout(2,1));
    condInput = new JTextField();
    condPanel1.add(condInput);
    condList = new DefaultListModel();
    condPanel1.add(new JScrollPane
		   (new JList(condList), 
		    ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS, 
		    ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS));
    condPanel.add("Center",condPanel1);

    JPanel condPanel2 = new JPanel();
    JButton addCBtn = new JButton("Add");
    addCBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	condList.addElement(condInput.getText());
	condInput.setText("");
      }
    });
    condPanel2.add(addCBtn);
    JButton delCBtn = new JButton("Delete");
    delCBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	condList.removeAllElements();
      }
    });
    condPanel2.add(delCBtn);
    JButton expCondBtn = new JButton("Build...");
    expCondBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	
	try {
	  //Lookup class
	  Class c = Class.forName(Cpe.sharedInstance().expClassName);

	  //Create new instance
	  Object expBuilder = null;
	  expBuilder = c.newInstance();

	  //Fetch method and invoke it
	  Class parameters[] = new Class[0];
	  Method m = c.getMethod("buildInputConstraint",parameters);
	  Object[] args = new Object[0];
	  Object target = new Object();
	  String result = (String) m.invoke(expBuilder, args);

	  if (!(result.equals(""))){
	    condInput.setText(result);
	  }
	}
	catch (IllegalAccessException eill){}
	catch (InstantiationException inst){
	  JOptionPane.showMessageDialog
	    (Cpe.sharedInstance().getFrame(), 
	     "Selected component is illegal. Consult the Options menu.",
	     "CPE Message", 
	     JOptionPane.WARNING_MESSAGE);
	  return;	
	}
	catch (InvocationTargetException etarg){}
	catch (ClassNotFoundException enotf){
	  JOptionPane.showMessageDialog
	    (Cpe.sharedInstance().getFrame(), 
	     "Selected component is illegal. Consult the Options menu.",
	     "CPE Message", 
	     JOptionPane.WARNING_MESSAGE);
	  return;
	}
	catch (NoSuchMethodException enos){
	  JOptionPane.showMessageDialog
	    (Cpe.sharedInstance().getFrame(), 
	     "Selected component is illegal. Consult the Options menu.",
	     "CPE Message", 
	     JOptionPane.WARNING_MESSAGE);
	  return;
	}
      }
    });
    condPanel2.add(expCondBtn);
    condPanel.add("South",condPanel2);
    tab.addTab("Conditions",null,condPanel);


    //effects gui
    JPanel effPanel = new JPanel();
    effPanel.setLayout(new BorderLayout(25,5));
    JPanel effPanel1 = new JPanel();
    effPanel1.setLayout(new GridLayout(2,1));
    effInput = new JTextField();
    effPanel1.add(effInput);
    effList = new DefaultListModel();
    effPanel1.add(new JScrollPane
		  (new JList(effList), 
		   ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS, 
		   ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS));
    effPanel.add("Center",effPanel1);

    JPanel effPanel2 = new JPanel();
    JButton addEBtn = new JButton("Add");
    addEBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	effList.addElement(effInput.getText());
	effInput.setText("");
      }
    });
    effPanel2.add(addEBtn);
    JButton delEBtn = new JButton("Delete");
    delEBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	effList.removeAllElements();
      }
    });
    effPanel2.add(delEBtn);
    effPanel.add("South",effPanel2);
    tab.addTab("Effects",null,effPanel);


    //other gui
    JPanel otherPanel = new JPanel();
    otherPanel.setLayout(new BorderLayout(25,5));
    JPanel otherPanel1 = new JPanel();
    otherPanel1.setLayout(new GridLayout(2,1));
    otherInput = new JTextField();
    otherPanel1.add(otherInput);
    otherList = new DefaultListModel();
    otherPanel1.add(new JScrollPane
		  (new JList(otherList), 
		   ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS, 
		   ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS));
    otherPanel.add("Center",otherPanel1);

    JPanel otherPanel2 = new JPanel();
    JButton addOtherBtn = new JButton("Add");
    addOtherBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	otherList.addElement(otherInput.getText());
	otherInput.setText("");
      }
    });
    otherPanel2.add(addOtherBtn);
    JButton delOtherBtn = new JButton("Delete");
    delOtherBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
	otherList.removeAllElements();
      }
    });
    otherPanel2.add(delOtherBtn);
    otherPanel.add("South",otherPanel2);
    tab.addTab("Other",null,effPanel);

    this.getContentPane().add("Center",tab);
    
    JPanel yn = new JPanel();
    btnOK = new Button("OK");
    yn.add (btnOK);
    btnCancel = new Button("Cancel");
    yn.add (btnCancel);
    this.getContentPane().add ("South",yn);
    
    importLists();

    this.setBounds(0,0,385,290);
  }
  
  // Pop down the window when the button is clicked.
  public boolean action(Event e, Object arg) {
    
    if("Cancel".equals(arg) == false) {
      //update value as long as cancel wasn't pressed.
      String tempString = txtName.getText();
      m_panel.process.setLabel(tempString);

      if (group.getSelection().getActionCommand().equals("sf")) {
	m_panel.process.setStartFinishFlag(true);
      } else {
	m_panel.process.setStartFinishFlag(false);
      }

      updateLists();
    }
    this.hide();
    this.dispose();
    m_panel.process.m_sheet = null;
    m_panel.repaint();
    
    return true;
  }

  private void updateLists() {
    String s = new String();

    m_panel.process.requirements.removeAllElements();
    m_panel.process.preferences.removeAllElements();
    m_panel.process.variables.removeAllElements();
    m_panel.process.preconditions.removeAllElements();
    m_panel.process.effects.removeAllElements();
    m_panel.process.resources.removeAllElements();

    m_panel.process.resources.removeAllElements();
    m_panel.process.resources.removeAllElements();

    for  (Enumeration e =  reqList.elements() ; e.hasMoreElements()  ;)  
      {s = (String) e.nextElement();
      m_panel.process.requirements.addElement(s); }
    for  (Enumeration e =  prefList.elements() ; e.hasMoreElements()  ;)  
      {s = (String) e.nextElement(); 
      m_panel.process.preferences.addElement(s); }
    for  (Enumeration e =  varList.elements() ; e.hasMoreElements()  ;)  
      {s = (String) e.nextElement(); 
      m_panel.process.variables.addElement(s); }
    for  (Enumeration e =  condList.elements() ; e.hasMoreElements()  ;)  
      {s = (String) e.nextElement(); 
      m_panel.process.preconditions.addElement(s); }
    for  (Enumeration e =  effList.elements() ; e.hasMoreElements()  ;)  
      {s = (String) e.nextElement(); 
      m_panel.process.effects.addElement(s); }
    for  (Enumeration e =  resList.elements() ; e.hasMoreElements()  ;)  
      {s = (String) e.nextElement(); 
      m_panel.process.resources.addElement(s); }
  }

  private void importLists() {
    String s = new String();
    for  (Enumeration e =  m_panel.process.requirements.elements() ; 
	  e.hasMoreElements()  ;)  
      {s = (String) e.nextElement(); reqList.addElement(s); }
    for  (Enumeration e =  m_panel.process.preferences.elements() ; 
	  e.hasMoreElements()  ;)  
      {s = (String) e.nextElement(); prefList.addElement(s); }
    for  (Enumeration e =  m_panel.process.variables.elements() ; 
	  e.hasMoreElements()  ;)  
      {s = (String) e.nextElement(); varList.addElement(s); }
    for  (Enumeration e =  m_panel.process.preconditions.elements() ; 
	  e.hasMoreElements()  ;)  
      {s = (String) e.nextElement(); condList.addElement(s); }
    for  (Enumeration e =  m_panel.process.effects.elements() ; 
	  e.hasMoreElements()  ;)  
      {s = (String) e.nextElement(); effList.addElement(s); }
    for  (Enumeration e =  m_panel.process.resources.elements() ; 
	  e.hasMoreElements()  ;)  
      {s = (String) e.nextElement(); resList.addElement(s); }
  }

  public void show() {
    tab.setSelectedIndex(0);
    super.show();
  }
}

